SystemOrganization addCategory: #RedditFeed!

Object subclass: #RFFeedCategory
	instanceVariableNames: 'what'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RedditFeed'!

RFFeedCategory subclass: #RFAllReddit
	instanceVariableNames: 'when'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RedditFeed'!

!RFAllReddit class methodsFor: 'accessing-description' stamp: 'pmm 8/24/2006 20:38'!
descriptionWhen
	^(MASingleOptionDescription selector: #when label: 'when' priority: 200)
		options: self whens;
		beRequired;
		yourself! !

!RFAllReddit class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 21:01'!
label
	^'all reddit'! !

!RFAllReddit class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:41'!
whenDictionary
	^Dictionary new
		at: 'this hour' put: 'hour';
		at: 'today' put: 'day';
		at: 'this week' put: 'week';
		at: 'this month' put: 'month';
		at: 'all-time' put: 'all';
		yourself! !

!RFAllReddit class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:37'!
whens
	^#(
		'this hour'
		'today'
		'this week'
		'this month'
		'all-time'
	)! !

!RFAllReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:15'!
baseUrl
	^'http://reddit.com/browse.js'! !

!RFAllReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 23:16'!
fullUrl
	^super fullUrl, '&', self whenParameter! !

!RFAllReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:36'!
when
	^when! !

!RFAllReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:36'!
when: aString
	when := aString! !

!RFAllReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:21'!
whenParameter
	^'t=day', self whenParameterValue! !

!RFAllReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:21'!
whenParameterValue
	^self class whenDictionary at: self when! !

!RFFeedCategory class methodsFor: 'accessing-description' stamp: 'pmm 8/24/2006 20:35'!
descriptionWhat
	^(MASingleOptionDescription selector: #what label: 'whay' priority: 100)
		options: self whats;
		beRequired;
		yourself! !

!RFFeedCategory class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:33'!
whatDictionary
	^Dictionary new
		at: 'hottest' put: 'hot';
		at: 'newest' put: 'new';
		at: 'top' put: 'highscore';
		yourself! !

!RFFeedCategory class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:32'!
whats
	^#(
		'hottest'
		'newest'
		'top'
	)! !

!RFFeedCategory methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:16'!
baseUrl
	self subclassResponsibility ! !

!RFFeedCategory methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:39'!
fullUrl
	^self baseUrl, '?', self whatParameter! !

!RFFeedCategory methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:34'!
what
	^what! !

!RFFeedCategory methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:34'!
what: aString
	what := aString! !

!RFFeedCategory methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:18'!
whatParameter
	^'s=', self whatParameterValue! !

!RFFeedCategory methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:17'!
whatParameterValue
	^self class whatDictionary at: self what! !

RFFeedCategory subclass: #RFUserReddit
	instanceVariableNames: 'where who'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RedditFeed'!

!RFUserReddit class methodsFor: 'accessing-description' stamp: 'pmm 8/24/2006 20:31'!
descriptionWhere
	^(MASingleOptionDescription selector: #where label: 'where' priority: 200)
		options: self wheres;
		beRequired;
		yourself! !

!RFUserReddit class methodsFor: 'accessing-description' stamp: 'pmm 8/24/2006 20:31'!
descriptionWho
	^(MAStringDescription selector: #who label: 'who' priority: 300)
		beRequired;
		yourself! !

!RFUserReddit class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 21:01'!
label
	^'only from one user'! !

!RFUserReddit class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 19:59'!
wheres
	^#(
		'submitted by'
		'saved by'
		'liked by'
		'disliked by'
	)! !

!RFUserReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:19'!
baseUrl
	^'http://reddit.com/user/', self who, '/', self whereScript! !

!RFUserReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:26'!
where
	^where! !

!RFUserReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:26'!
where: aString
	where := aString! !

!RFUserReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:19'!
whereScript
	^self where substrings first! !

!RFUserReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:27'!
who
	^who! !

!RFUserReddit methodsFor: 'accessing' stamp: 'pmm 8/24/2006 20:27'!
who: aString
	who := aString! !

PRBoxWidget subclass: #RFFeedWidget
	instanceVariableNames: 'feedCategory'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RedditFeed'!

!RFFeedWidget commentStamp: 'pmm 8/24/2006 20:38' prior: 0!
http://reddit.com/widget!

!RFFeedWidget class methodsFor: 'accessing-description' stamp: 'pmm 8/24/2006 22:26'!
descriptionFeedCategory
	^(MAToOneRelationDescription selector: #feedCategory label: 'Feed' priority: 300)
		classes: (Array with: RFAllReddit with: RFUserReddit);
		beRequired;
		yourself! !

!RFFeedWidget class methodsFor: 'testing' stamp: 'pmm 8/24/2006 19:50'!
isAbstract
	^false! !

!RFFeedWidget class methodsFor: 'accessing' stamp: 'pmm 8/24/2006 19:50'!
label
	^ 'Reddit Feed'! !

!RFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:24'!
feedCategory
	^feedCategory! !

!RFFeedWidget methodsFor: 'accessing' stamp: 'pmm 8/24/2006 22:24'!
feedCategory: aFeedCategory
	feedCategory := aFeedCategory! !

!RFFeedWidget methodsFor: 'rendering' stamp: 'pmm 8/26/2006 00:05'!
renderRedditScriptOn: html
	html script
		url: self feedCategory fullUrl;
		with: '' "stupid fucking seaside"! !

!RFFeedWidget methodsFor: 'rendering' stamp: 'pmm 8/24/2006 22:49'!
renderSettingsLinkOn: html
	"copy pasted from PRCommandsWidget"
	html anchor
		accessKey: PRComponentSettings accessKey;
		goto: (self context
			structure: self context structure
			command: PRComponentSettings new);
		text: PRComponentSettings shortLabel! !

!RFFeedWidget methodsFor: 'rendering' stamp: 'pmm 8/24/2006 22:50'!
renderWidgetOn: html
	self feedCategory isNil
		ifTrue: [ self renderSettingsLinkOn: html ]
		ifFalse: [ self renderRedditScriptOn: html ]! !
